include doszip.inc
include stdio.inc
include stdlib.inc
include string.inc
include keyb.inc

externdef	IDD_DZPanelFilter:dword
externdef	IDD_DZFindFile:dword

ID_READCOUNT	equ 1*16
ID_READMASK	equ 2*16
ID_DIRECTORY	equ 3*16
ID_OK		equ 4*16
ID_LOADPATH	equ 5*16
ID_CANCEL	equ 6*16

.data

path_dd		dd 0
cp_directory	db 'Directory',0
cp_filter	db 'Filter',0
format_d	db "%d",0

filter_keys	label word
GCMD KEY_F3,	cmfilter_load
GCMD KEY_F4,	cmfilter_date
		dd 0

.code

event_loadpath proc private
local path[WMAXPATH]:byte
	mov path,0
	invoke tools_idd,WMAXPATH,addr path,addr cp_directory
	push eax
	call msloop
	pop eax
	mov dl,path
	.if !dl || !eax || eax == MOUSECMD
	    mov eax,_C_NORMAL
	.else
	    invoke expenviron,addr path
	    invoke strcpy,path_dd,eax
	    mov eax,_C_REOPEN
	.endif
	ret
event_loadpath endp

PanelFilter proc private uses esi edi ebx panel:dword, xpos:byte
local	DLG_DZPanelFilter:dword
	mov esi,IDD_DZPanelFilter
	mov al,xpos
	mov [esi+6],al
	.if rsopen(IDD_DZPanelFilter)
	    mov DLG_DZPanelFilter,eax
	    mov ebx,panel
	    mov esi,[ebx].S_PANEL.pn_wsub
	    mov edi,eax
	    mov [edi].S_TOBJ.to_proc[ID_LOADPATH],event_loadpath
	    mov eax,[edi].S_TOBJ.to_data[ID_DIRECTORY]
	    mov path_dd,eax
	    invoke strcpy,eax,[esi].S_WSUB.ws_path
	    invoke strcpy,[edi].S_TOBJ.to_data[ID_READMASK],[esi].S_WSUB.ws_mask
	    invoke sprintf,[edi].S_TOBJ.to_data[ID_READCOUNT],addr format_d,[esi].S_WSUB.ws_maxfb
	    invoke dlinit,DLG_DZPanelFilter
	    .if dlevent(DLG_DZPanelFilter)
		push [esi].S_WSUB.ws_mask
		push [edi].S_TOBJ.to_data[ID_READMASK]
		push [esi].S_WSUB.ws_path
		push [edi].S_TOBJ.to_data[ID_DIRECTORY]
		invoke atol,[edi].S_TOBJ.to_data[ID_READCOUNT]
		mov edi,eax
		call strcpy
		call strcpy
		invoke dlclose,DLG_DZPanelFilter
		.if edi != [esi].S_WSUB.ws_maxfb && edi > 10 && \
		    edi < WMAXFBLOCK && [esi].S_WSUB.ws_fcb != 0
		    invoke wsclose,esi
		    push [esi].S_WSUB.ws_maxfb
		    mov  [esi].S_WSUB.ws_maxfb,edi
		    invoke wsopen,esi
		    pop edx
		    .if eax
			mov eax,panel
			call panel_reread
			mov eax,panel
			.if eax == cpanel
			    invoke cominit,esi
			.endif
			mov eax,1
		    .else
			mov [esi].S_WSUB.ws_maxfb,edx
			invoke wsopen,esi
			xor eax,eax
		    .endif
		.endif
	    .else
		invoke dlclose,DLG_DZPanelFilter
		xor eax,eax
	    .endif
	.endif
	ret
PanelFilter endp

cmafilter proc
	invoke PanelFilter,panela,3
	ret
cmafilter endp

cmbfilter proc
	invoke PanelFilter,panelb,42
	ret
cmbfilter endp

cmfilter_load proc uses esi edi ebx
local	filt[FILT_MAXSTRING]:byte
local	dialog:dword
	mov eax,tdialog
	mov dialog,eax
	mov edi,IDD_DZFindFile
	mov dl,[edi].S_ROBJ.rs_count
	mov ebx,tdialog
	mov eax,1
	.if [ebx].S_DOBJ.dl_count == dl
	    mov eax,0D0Dh
	.endif
	mov edi,eax
	.if [ebx].S_DOBJ.dl_index <= al
	    invoke tools_idd,128,addr filt,addr cp_filter
	    mov esi,eax
	    call msloop
	    mov eax,_C_NORMAL
	    .if esi
		.if esi != MOUSECMD
		    mov ebx,dialog
		    mov edx,edi
		    .if [ebx].S_DOBJ.dl_index != dl
			mov [ebx].S_DOBJ.dl_index,dh
		    .endif
		    mov al,[ebx].S_DOBJ.dl_index
		    shl eax,4
		    mov ebx,[ebx].S_DOBJ.dl_object
		    add ebx,eax
		    invoke strcpy,[ebx].S_TOBJ.to_data,addr filt
		    mov eax,_C_REOPEN
		.endif
	    .endif
	.else
	    mov eax,_C_NORMAL
	.endif
	ret
cmfilter_load endp

cmfilter_date proc private uses edi ebx
  ifdef __CAL__
	mov edi,tdialog
	mov al,[edi].S_DOBJ.dl_index
	.if al == 2 || al == 3
	    .if cmcalendar()
		mov    ebx,eax
		mov    edi,tdialog
		movzx  eax,[edi].S_DOBJ.dl_index
		inc    eax
		shl    eax,4
		add    edi,eax
		invoke sprintf,[edi].S_TOBJ.to_data,addr cp_datefrm,edx,ebx,ecx
		mov    eax,_C_REOPEN
		jmp    @F
	    .endif
	.endif
  endif
	mov eax,_C_NORMAL
      @@:
	ret
cmfilter_date endp

cmfilter proc
	invoke filter_edit,addr opfilter,addr filter_keys
	ret
cmfilter endp

cmloadpath proc
	sub	esp,WMAXPATH
	mov	eax,esp
	mov	path_dd,eax
	push	eax
	call	event_loadpath
	cmp	eax,_C_REOPEN
	pop	eax
	jne	cmloadpath_end
	call	cpanel_setpath
    cmloadpath_end:
	add	esp,WMAXPATH
	ret
cmloadpath endp

	END
