include doszip.inc
include keyb.inc

.data

pcellwb dw 256 dup(0720h)
pcell_a S_XCEL <_D_BACKG or _D_MYBUF,1,1,<2,2,12,1>,pcellwb,<2,2,12,1>>
pcell_b S_XCEL <_D_BACKG or _D_MYBUF,1,1,<2,2,12,1>,pcellwb,<2,2,12,1>>
prect_a S_DOBJ <_D_CLEAR or _D_COLOR,0,0,<0,1,40,20>,0,0>
prect_b S_DOBJ <_D_CLEAR or _D_COLOR,0,0,<40,1,40,20>,0,0>
wspanela S_WSUB <0,MAXFBLOCK,path_a.wp_flag,path_a.wp_mask,
	path_a.wp_file,path_a.wp_arch,path_a.wp_path,0>
wspanelb S_WSUB <0,MAXFBLOCK,path_b.wp_flag,path_b.wp_mask,
	path_b.wp_file,path_b.wp_arch,path_b.wp_path,0>
spanela S_PANEL <path_a,0,0,0,0,pcell_a,prect_a,wspanela,0>
spanelb S_PANEL <path_b,0,0,0,0,pcell_b,prect_b,wspanelb,0>

.code

panel_getb proc
	mov eax,panela
	.if eax == cpanel
	    mov eax,panelb
	.endif
	ret
panel_getb endp

cpanel_state proc
	mov eax,cpanel
cpanel_state endp

panel_state proc
	push edx
	mov edx,eax
	mov eax,[eax].S_PANEL.pn_dialog
	mov eax,[eax].S_DOBJ.dl_wp
	.if eax
	    mov eax,[edx].S_PANEL.pn_wsub
	    mov eax,[eax].S_WSUB.ws_fcb
	    .if eax
		mov eax,edx
	    .endif
	.endif
	pop edx
	ret
panel_state endp

panel_stateab proc
	mov eax,panela
	.if panel_state()
	    mov eax,panelb
	    invoke panel_state
	.endif
	ret
panel_stateab endp

panel_curobj proc
	mov edx,eax
	mov eax,[eax].S_PANEL.pn_wsub
	.if eax
	    mov eax,[edx].S_PANEL.pn_fcb_index
	    add eax,[edx].S_PANEL.pn_cel_index
	    .if wsfblk([edx].S_PANEL.pn_wsub,eax)
		mov edx,eax
		add eax,S_FBLK.fb_name
	    .endif
	.endif
	ret
panel_curobj endp

panel_findnext proc
	invoke  wsffirst,[eax].S_PANEL.pn_wsub
	jz	@F
	mov	edx,eax
	add	eax,S_FBLK.fb_name
      @@:
	ret
panel_findnext endp

panel_hide proc uses ebx
	mov	ebx,eax
	invoke  prect_close
	invoke  wsfree,[ebx].S_PANEL.pn_wsub
	mov	eax,ebx
	ret
panel_hide endp

panel_show proc
	mov	edx,[eax].S_PANEL.pn_path
	or	[edx].S_PATH.wp_flag,_W_VISIBLE
	invoke  panel_update
	ret
panel_show endp

panel_selected proc uses esi
	mov edx,eax
	xor eax,eax
	mov ecx,[edx].S_PANEL.pn_fcb_count
	.if ecx
	    mov edx,[edx].S_PANEL.pn_wsub
	    mov esi,[edx].S_WSUB.ws_fcb
	    .if esi
		.while ecx
		    mov edx,[esi]
		    .if [edx].S_FBLK.fb_flag & _FB_SELECTED
			inc eax
		    .endif
		    add esi,4
		    dec ecx
		.endw
	    .endif
	.endif
	ret
panel_selected endp

panel_setid proc	; panel:AX, index:DX
	push eax
	push edx
	mov edx,eax
	xor eax,eax
	mov [edx].S_PANEL.pn_cel_index,eax
	mov [edx].S_PANEL.pn_fcb_index,eax
	mov eax,edx
	call pcell_set
	pop eax
	pop edx
	.if eax < [edx].S_PANEL.pn_cel_count
	    mov [edx].S_PANEL.pn_cel_index,eax
	.else
	    sub eax,[edx].S_PANEL.pn_cel_count
	    inc eax
	    mov [edx].S_PANEL.pn_fcb_index,eax
	    mov eax,[edx].S_PANEL.pn_cel_count
	    dec eax
	    mov [edx].S_PANEL.pn_cel_index,eax
	.endif
	ret
panel_setid endp

panel_setactive proc uses esi edi
	mov esi,eax
	mov edi,cpanel
	and cflag,not _C_PANELID
	mov eax,[esi].S_PANEL.pn_path
	.if [eax].S_PATH.wp_flag & _W_PANELID
	    or cflag,_C_PANELID
	.endif
	invoke cominit,[esi].S_PANEL.pn_wsub
	invoke dlclose,[edi].S_PANEL.pn_xl
	mov cpanel,esi
	mov eax,edi
	invoke panel_putinfo
	.if cflag & _C_WIDEVIEW && esi != edi
	    mov eax,esi
	    .if panel_state()
		mov eax,edi
		invoke prect_hide
		mov eax,[edi].S_PANEL.pn_path
		or [eax].S_PATH.wp_flag,_W_WHIDDEN
		mov eax,[esi].S_PANEL.pn_path
		and [eax].S_PATH.wp_flag,not _W_WHIDDEN
		mov eax,esi
		invoke panel_show
	    .endif
	.else
	    mov eax,esi
	    invoke pcell_show
	    mov eax,esi
	    invoke panel_putinfo
	.endif
	ret
panel_setactive endp

panel_sethdd proc uses esi edi panel:dword, hdd:dword
	invoke  getdrive
	push	eax
	mov	esi,panel
	invoke  _disk_init,hdd
	mov	edi,eax
	invoke  historysave
	invoke  wschdrv,[esi].S_PANEL.pn_wsub,edi
	mov	eax,esi
	invoke  panel_read
	pop	eax
	.if esi == cpanel
	    invoke cominit,[esi].S_PANEL.pn_wsub
	.endif
	invoke panel_putinfozx
	ret
panel_sethdd endp

panel_toggle proc uses esi edi
	mov esi,eax
	invoke panel_getb
	mov edi,eax
	invoke panel_state
	mov ecx,eax
	mov edx,[esi].S_PANEL.pn_dialog
	mov eax,[edx]
	.if eax & _D_ONSCR
	    mov eax,edi
	    mov edi,edx
	    .if ecx && esi == cpanel
		invoke panel_setactive
	    .endif
	    mov eax,[edi]
	    .if eax & _D_ONSCR
		mov eax,esi
		invoke panel_hide
	    .endif
	.else
	    mov eax,esi
	    invoke panel_show
	    mov edi,cpanel
	    mov edi,[edi].S_PANEL.pn_dialog
	    mov eax,[edi]
	    .if !(eax & _D_ONSCR)
		mov eax,esi
		invoke panel_setactive
	    .endif
	.endif
	xor eax,eax
	ret
panel_toggle endp

panel_toggleact proc
	.if panel_stateab()
	    invoke historysave
	    invoke panel_getb
	    invoke panel_setactive
	    mov eax,1
	.endif
	test eax,eax
	ret
panel_toggleact endp

panel_update proc uses esi
	mov	esi,eax
	mov	eax,[eax].S_PANEL.pn_path
	mov	eax,[eax].S_PATH.wp_flag
	and	eax,_W_VISIBLE
	jz	@F
	mov	eax,esi
	invoke  panel_read
	mov	eax,esi
	invoke  panel_redraw
      @@:
	ret
panel_update endp

panel_xorinfo proc
	mov	edx,[eax].S_PANEL.pn_path
	mov	ecx,eax
	mov	eax,[edx].S_PATH.wp_flag
	xor	eax,_W_DRVINFO
	test	eax,_W_DRVINFO
	jz	@F
	or	eax,_W_MINISTATUS
      @@:
	mov	[edx].S_PATH.wp_flag,eax
	mov	eax,ecx
	invoke  panel_redraw
	ret
panel_xorinfo endp

panel_xormini proc
	mov	edx,eax
	mov	eax,[eax].S_PANEL.pn_path
	xor	[eax].S_PATH.wp_flag,_W_MINISTATUS
	test	[eax].S_PATH.wp_flag,_W_VISIBLE
	mov	eax,edx
	jz	@F
	invoke  panel_redraw
      @@:
	invoke  msloop
	xor	eax,eax
	ret
panel_xormini endp

panel_xycmd proc uses esi edi panel:dword, xpos:dword, ypos:dword
local rect:S_RECT
local endx:dword
	mov eax,panel
	.if panel_state()
	    mov esi,eax
	    sub eax,eax
	    mov edi,[esi].S_PANEL.pn_dialog
	    .if [edi].S_DOBJ.dl_flag & _D_ONSCR
		mov eax,[edi].S_DOBJ.dl_rect
		mov rect,eax
		movzx eax,al
		add al,rect.rc_col
		dec al
		mov endx,eax
		invoke rcxyrow,dword ptr rect,xpos,ypos
		mov edx,eax
		sub eax,eax
		.if edx
		    .if edx == 1
			mov eax,_XY_MOVEUP
		    .else
			mov edi,edx
			.if edx == 2
			    mov dl,rect.rc_x
			    .if xpos == edx
				mov eax,_XY_INSIDE
			    .else
				add edx,2
				.if xpos <= edx
				    mov eax,_XY_NEWDISK
				.else
				    inc edx
				    .if edx == xpos
					mov eax,_XY_CONFIG
				    .else
					mov eax,_XY_MOVEUP
				    .endif
				.endif
			    .endif
			.else
			    mov ebx,[esi].S_PANEL.pn_path
			    .if [ebx].S_PATH.wp_flag & _W_MINISTATUS
				mov dl,rect.rc_row
				sub dl,2
				.if [ebx].S_PATH.wp_flag & _W_DRVINFO
				    sub dl,2
				    .if !(cflag & _C_HORIZONTAL)
					dec dl
				    .endif
				.endif
				mov rect.rc_row,dl
				.if edi > edx
				    mov eax,_XY_MOVEDOWN
				.elseif edi != edx
				    jmp panel_xycmd_11
				.else
				    mov dl,rect.rc_x
				    add dl,2
				    .if xpos == edx
					mov ax,_XY_DRVINFO
				    .else
					jmp panel_xycmd_01
				    .endif
				.endif
			    .else
				mov dl,rect.rc_row
				.if edx != edi
				    jmp panel_xycmd_11
				.else
				    jmp panel_xycmd_01
				.endif
			    .endif
			.endif
		    .endif
		.endif
	    .endif
	.endif
  toend:
	ret
    panel_xycmd_01:
	mov	edx,endx
	sub	edx,2
	mov	eax,_XY_MINISTATUS
	cmp	edx,xpos
	je	toend
	mov	eax,_XY_MOVEDOWN
	jmp	toend
    panel_xycmd_11:
	xor edi,edi
	.while edi < [esi].S_PANEL.pn_cel_count
	    invoke pcell_getrect,[esi].S_PANEL.pn_xl,edi
	    invoke rcxyrow,eax,xpos,ypos
	    mov eax,_XY_INSIDE
	    .if !ZERO?
		mov eax,_XY_FILE
		.break
	    .endif
	    inc edi
	.endw
	jmp toend
panel_xycmd endp

panel_redraw proc uses esi
	mov	esi,eax
	mov	eax,[eax].S_PANEL.pn_path
	mov	eax,[eax].S_PATH.wp_flag
	and	eax,_W_VISIBLE
	jz	@F
	mov	eax,esi
	invoke  prect_open
	xor	eax,eax
	invoke  panel_putinfoax
	mov	eax,1
	cmp	esi,cpanel
	jne	@F
	mov	eax,esi
	invoke  pcell_show
      @@:
	ret
panel_redraw endp

redraw_panel proc
	mov	edx,[eax].S_PANEL.pn_path
	or	[edx].S_PATH.wp_flag,_W_VISIBLE
	invoke  panel_redraw
	ret
redraw_panel endp

redraw_panels proc
	mov	eax,panelb
	invoke  prect_hide
	push	eax
	mov	eax,panela
	invoke  prect_hide
	test	eax,eax
	jz	@F
	mov	eax,panela
	invoke  redraw_panel
     @@:
	pop	eax
	test	eax,eax
	jz	@F
	mov	eax,panelb
	invoke  redraw_panel
      @@:
	ret
redraw_panels endp

	END
